#!/bin/sh

dev='eth0:'
sleep_sekunden='1'

last_in_bytes='0'
last_out_bytes='0'
first=0
max_in_rate='0'
max_out_rate='0'

while [ 0 -lt 1 ]
do
    # /proc/net/dev auslesen und Daten fuer entspr. NIC ermitteln
    zeile=`cat /proc/net/dev | grep $dev | sed s/$dev// | sed s/^" "*// | sed s/"  "*/,/g`
    in_bytes=`echo $zeile | cut -d , -f 1`
    out_bytes=`echo $zeile | cut -d , -f 9`
    
    # Uebertragungsgeschwindigkeit ausrechnen
    in_rate=`expr $in_bytes - $last_in_bytes`
    in_rate=`expr $in_rate / $sleep_sekunden`
    out_rate=`expr $out_bytes - $last_out_bytes`
    out_rate=`expr $out_rate / $sleep_sekunden`

    # ab dem 2. Durchlauf Maxima merken
    if [ $first -gt 0 ]; then
        if [ $in_rate -gt $max_in_rate ]; then
		max_in_rate=$in_rate
        fi
        if [ $out_rate -gt $max_out_rate ]; then
		max_out_rate=$out_rate
        fi
    else
	first=1
    fi
    
    # Daten ausgeben
    echo "In: $in_bytes -> $in_rate Bytes/s (max. $max_in_rate) | Out: $out_bytes -> $out_rate Bytes/s (max. $max_out_rate)"

    # letzten Werte merken
    last_in_bytes=$in_bytes
    last_out_bytes=$out_bytes 

    sleep $sleep_sekunden
done
